<!--- Decode digital convergance's cuecat.
Author: Joe S <joe@technocraft.com>
Version: 1.0
CF: 4.x
This code is based on the white paper written by Stephen Satchell 
http://www.fluent-access.com/wtpapers/cuecat/
This runs through a base64 and XOR algorithim.
This code is free to use for non-commercial purposes.
Any commercial use requires written consent from the author and Stephen Satchell


Input: Output from cuecat
Output: #output#: [serial no].[barcode type].[barcode]
--->

<!--- Do some error checking --->
<CFIF Len(attributes.string)>
	<!--- Create the base table for conversion --->
	<CFSCRIPT>
	basemap = StructNew(); //BaseMap for conversion
	j = 0; //Counter for structure
	XORConstant = "01000011"; // DC uses this as their "encryption"
	// Create char map
	for (i=97;i LTE 122;i=i + 1) { StructInsert(basemap,Chr(i),j); j=j+1;}; //[a-z]
	// Ughh!!
	for (i=65;i LTE 90;i=i + 1) { StructInsert(basemap,Chr(i) & '_',j); j=j+1;}; //[A-Z]
	for (i=48;i LTE 57;i=i + 1) { StructInsert(basemap,Chr(i),j); j=j+1;}; //[0-9]
	for (i=44;i LTE 45;i=i + 1) { StructInsert(basemap,Chr(i),j); j=j+1;}; //[,-]
	</CFSCRIPT>
	
	<!--- Init and start decoding --->
	<CFSET final_output = "">
	<CFLOOP LIST="#attributes.string#" INDEX="k" DELIMITERS=".">
	<CFIF Len(trim(k))>
		<CFSCRIPT>
		q = k; //Set String
		b = ""; //Binary String
		// Since structures seem to be case insensitive I added a marker
		// Run trough string convert to base and binary
		for (i=1; i LTE Len(q); i=i + 1) { c = Mid(q,i,1); if (asc(c) GTE 65 AND asc(c) LTE 90) { c = c & '_';} 
			d = FormatBaseN(StructFind(basemap,c),2);
			while (len(d) LT 6) { d = Insert(0,d,0); };
			b = b & d;};
		// Parse the string into 8 bits and XOR against constant	
		x="";
		for (i=1; i LTE Len(b); i = i+8) {d = Mid(b,i,8); d= BitXOR(InputbaseN(d,2),InputBaseN(XORConstant,2)); x = x & d & ',';};	
		//Almost done, now reassemble the string
		final = "";
		for (i=1;i LTE ListLen(x);i=i+1) {final = final & Chr(ListGetAt(x,i));}; 
		</CFSCRIPT>
		<CFSET final_output = ListAppend(final_output,final,".")>
	</CFIF>
	</CFLOOP>
	<CFSET caller.output = final_output>
<CFELSE>
	<CFSET caller.output = "No Input">
</CFIF>

